commit d1a657f2dd38de5713ff5c8c3382f4d2a72db157
Author: freddy77 <freddy77>
Date:   Wed Jan 27 15:35:18 2010 +0000

    fix thread issue with SSPI

diff --git a/ChangeLog b/ChangeLog
index 50266c4..03a72f7 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Wed Jan 27 16:34:28 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/sspi.c: fix thread issue with SSPI
+
 Wed Jan 27 16:29:44 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tdsthread.h src/tds/Makefile.am src/tds/ptw32_MCS_lock.c:
 	* src/tds/win_mutex.c:
@@ -2230,4 +2233,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2965 2010/01/27 15:32:02 freddy77 Exp $
+$Id: ChangeLog,v 1.2966 2010/01/27 15:35:18 freddy77 Exp $
diff --git a/src/tds/sspi.c b/src/tds/sspi.c
index 51ee44e..d660534 100644
--- a/src/tds/sspi.c
+++ b/src/tds/sspi.c
@@ -38,6 +38,7 @@
 #include <rpc.h>
 
 #include "tds.h"
+#include "tdsthread.h"
 #include "tdsstring.h"
 #include "replacements.h"
 
@@ -45,7 +46,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: sspi.c,v 1.5 2010/01/27 12:22:00 freddy77 Exp $");
+TDS_RCSID(var, "$Id: sspi.c,v 1.6 2010/01/27 15:35:18 freddy77 Exp $");
 
 /**
  * \ingroup libtds
@@ -68,37 +69,48 @@ typedef struct tds_sspi_auth
 
 static HMODULE secdll = NULL;
 static PSecurityFunctionTableA sec_fn = NULL;
+static TDS_MUTEX_DEFINE(sec_mutex);
 
 static int
 tds_init_secdll(void)
 {
-	/* FIXME therad safe !!! */
-	if (!secdll) {
-		OSVERSIONINFO osver;
-
-		memset(&osver, 0, sizeof(osver));
-		osver.dwOSVersionInfoSize = sizeof(osver);
-		if (!GetVersionEx(&osver))
-			return 0;
-		if (osver.dwPlatformId == VER_PLATFORM_WIN32_NT && osver.dwMajorVersion <= 4)
-			secdll = LoadLibrary("security.dll");
-		else
-			secdll = LoadLibrary("secur32.dll");
-		if (!secdll)
-			return 0;
-	}
-	if (!sec_fn) {
-		INIT_SECURITY_INTERFACE_A pInitSecurityInterface;
+	int res = 0;
+
+	if (sec_fn)
+		return 1;
+
+	TDS_MUTEX_LOCK(&sec_mutex);
+	for (;;) {
+		if (!secdll) {
+			OSVERSIONINFO osver;
+
+			memset(&osver, 0, sizeof(osver));
+			osver.dwOSVersionInfoSize = sizeof(osver);
+			if (!GetVersionEx(&osver))
+				break;
+			if (osver.dwPlatformId == VER_PLATFORM_WIN32_NT && osver.dwMajorVersion <= 4)
+				secdll = LoadLibrary("security.dll");
+			else
+				secdll = LoadLibrary("secur32.dll");
+			if (!secdll)
+				break;
+		}
+		if (!sec_fn) {
+			INIT_SECURITY_INTERFACE_A pInitSecurityInterface;
 
-		pInitSecurityInterface = (INIT_SECURITY_INTERFACE_A) GetProcAddress(secdll, "InitSecurityInterfaceA");
-		if (!pInitSecurityInterface)
-			return 0;
+			pInitSecurityInterface = (INIT_SECURITY_INTERFACE_A) GetProcAddress(secdll, "InitSecurityInterfaceA");
+			if (!pInitSecurityInterface)
+				break;
 
-		sec_fn = pInitSecurityInterface();
-		if (!sec_fn)
-			return 0;
+			sec_fn = pInitSecurityInterface();
+			if (!sec_fn)
+				break;
+		}
+		res = 1;
+		break;
 	}
-	return 1;
+	TDS_MUTEX_UNLOCK(&sec_mutex);
+	return res;
 }
 
 static int

